# Part of Acrobat.

# Acrobat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published
# by the Free Software Foundation; either version 2 of the License,
# or (at your option) any later version.
#
# Acrobat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Acrobat; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA.

# Andrew Walkingshaw <andrew@lexical.org.uk>
# Joel Rosdahl <joel@rosdahl.net>
# Peter Corbett <ptc24@cam.ac.uk>
# Matthew Vernon <matthew@debian.org>


import string, cPickle, random, urllib, sys, time
from irclib import irc_lower, nm_to_n

# query karma
def karmaq(bot, cmd, nick, conn, public):
    # in public
    if public == 1:
        try:
            if bot.karma.dict.has_key(cmd.split()[1]):
                conn.privmsg(bot.channel, "%s has karma %s."
                             %(cmd.split()[1],
                                   bot.karma.dict[cmd.split()[1]]))
            else:
                conn.privmsg(bot.channel, "%s has no karma set." %
                             cmd.split()[1])
        except IndexError:
            conn.privmsg(bot.channel, "I have karma on %s items." %
                         len(bot.karma.dict.keys()))
    # in private
    else:
        try:
            if bot.karma.dict.has_key(cmd.split()[1]):
                conn.notice(nick, "%s has karma %s." %
                            (cmd.split()[1],
                             bot.karma.dict[cmd.split()[1]]))
            else:
                conn.notice(nick, "I have karma on %s items." %
                            len(bot.karma.dict.keys()))
        except IndexError:
            conn.notice(nick, "I have karma on %s items." %
                        len(bot.karma.dict.keys()))
# query bot status
def infoq(bot, cmd, nick, conn, public):
    if public == 1:
        conn.privmsg(bot.channel,
                     "I am Acrobat %s, on %s, as nick %s." %
                    (bot.revision.split()[1], bot.channel, conn.get_nickname()))
        conn.privmsg(bot.channel,
                     "My owner is %s; I have karma on %s items." %
                     (bot.owner, len(bot.karma.dict.keys())))
    else:
        conn.notice(nick, "I am Acrobat %s, on %s, as nick %s." %
                    (bot.revision.split()[1], bot.channel, conn.get_nickname()))
        conn.notice(nick, "My owner is %s; I have karma on %s items." %
                    (bot.owner, len(bot.karma.dict.keys())))

# trout someone
def troutq(bot, cmd, nick, conn, public):
    troutquotaq(bot, cmd, nick, conn, public, silent = 1)
    if bot.troutsilenced == 1:
        conn.notice(nick, "Sorry; I have been silenced by %s."
                    % bot.troutsilencer)
        return
    if bot.troutstock < 1:
        conn.notice(nick, "Too many trouts used recently; wait a while.")
    else:
        target = string.join(cmd.strip().split()[1:])
        if len(target) == 0:
            conn.notice(nick, "Who do you wish me to trout?")
            return
        me = bot.connection.get_nickname()
        trout_msg = random.choice(bot.trouts) 
        # The bot won't trout itself;
        if irc_lower(me) == irc_lower(target):
            target = nick
        if public == 0:
            if random.random() <= bot.config.selftroutrisk:
                trout_msg += "(at the instigation of %s)" % nick
        conn.action(bot.channel, trout_msg % target)
        bot.troutstock -= 1


# see how many trouts are left this minute

def troutquotaq(bot, cmd, nick, conn, public, silent = 0):
    if bot.troutsilenced == 1:
        if time.time()>=bot.troutquotatime:
            bot.troutsilenced = 0
        else:
            if public == 0 and silent == 0:
                conn.privmsg(nick, "Bot trouting currently silenced by %s."
                             % bot.troutsilencer)
            return
        
    if bot.troutsilenced == 0:
        if (time.time() - bot.troutquotatime) > bot.troutinctime:
            bot.troutstock += (
                (int(time.time() - bot.troutquotatime) / int(bot.troutinctime))
                * bot.troutincnum)
    if bot.troutstock > bot.maxtrouts:
        bot.troutstock = bot.maxtrouts

    bot.troutquotatime = time.time()
    
    if silent == 0:
        conn.privmsg(nick, "%s trouts armed." % bot.troutstock)

# Shut up trouting for a minute
def nofishq(bot, cmd, nick, conn, public):
    bot.troutstock = 0
    bot.troutsilenced = 1
    bot.troutsilencer = nick
    bot.troutquotatime = time.time()
    bot.troutquotatime += bot.config.trout_silence_delay # and add a timeout
    conn.notice(nick, "Fish stocks depleted, as you wish.")
                                                        
# rehash bot config
def reloadq(bot, cmd, nick, conn, public):
    if irc_lower(nick) == irc_lower(bot.owner):
        try:
            reload(bot.config)
            bot.trouts = bot.config.trouts
            conn.privmsg(nick, "Config reloaded.")
        except ImportError:
            conn.notice(nick, "Config reloading failed!")
    else:
        conn.notice(nick, "This command can only be invoked by my owner.")

# quit irc
def quitq(bot, cmd, nick, conn, public):
    if irc_lower(nick) == irc_lower(bot.owner):
        try:
            f = open(bot.karmafilename, "w")
            cPickle.dump(bot.karma, f)
            f.close()
        except IOError:
            sys.stderr.write("Problems dumping karma: probably lost :(")
        bot.die(msg = bot.config.quit_message)
    elif public == 1:
        conn.privmsg(nick, "Such aggression in public!")
    else:
        conn.notice(nick, "You're not my owner.")

def listq(bot, cmd, nick, conn, public):
    conn.notice(nick, "My known commands:")
    conn.notice(nick, string.join(bot.config.commands.keys(), " , "))
                
# google for something
def googleq(bot, cmd, nick, conn, public):
    cmdrest = string.join(cmd.split()[1:])
    #sys.stderr.write(conn)
    # "I'm Feeling Lucky" rather than try and parse the html
    targ = ("http://www.google.com/search?q=%s&btnI=I'm+Feeling+Lucky"
            % urllib.quote_plus(cmdrest))
    try:
        # get redirected and grab the resulting url for returning
        gsearch = urllib.urlopen(targ).geturl()
        if gsearch != targ: # we've found something
            if public == 0:
                conn.notice(nick, str(gsearch))
            else: # we haven't found anything.
                conn.privmsg(nick, str(gsearch))
        else:
            if public == 0:
                conn.notice(nick, "No pages found.")
            else:
                conn.privmsg(nick, "No pages found.")
    except IOError: # if the connection times out. This blocks. :(
        if public == 0:
            conn.notice(nick, "The web's broken. Waah!")
        else:
            conn.privmsg(nick, "The web's broken. Waah!")

### say to msg/channel            
def sayq(bot, cmd, nick, conn, public):
    if irc_lower(nick) == irc_lower(bot.owner):
        conn.privmsg(bot.channel, string.join(cmd.split()[1:]))
    else:
        conn.privmsg(nick, "You're not my owner!")

### action to msg/channel
def doq(bot, cmd, nick, conn, public):
    sys.stderr.write(irc_lower(bot.owner))
    sys.stderr.write(irc_lower(nick))
    if public == 0:
        if irc_lower(nick) == irc_lower(bot.owner):
            conn.action(bot.channel, string.join(cmd.split()[1:]))
        else:
            conn.privmsg(nick, "You're not my owner!")

###disconnect
# this should only be used for temporary breakage. It disconnects the bot
# for 60s, but should not be available to the public.
def disconnq(bot, cmd, nick, conn, public):
    if public == 0 and irc_lower(nick) == irc_lower(bot.owner):
        bot.disconnect(msg=bot.config.disconnect_message)

