# This file is part of Acrobat.
#
# Acrobat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published
# by the Free Software Foundation; either version 2 of the License,
# or (at your option) any later version.
#
# Acrobat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Acrobat; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA.

# Andrew Walkingshaw <andrew@lexical.org.uk>
# Joel Rosdahl <joel@rosdahl.net>
# Peter Corbett <ptc24@cam.ac.uk>
# Matthew Vernon <matthew@debian.org>


# Acrobat configuration file
# this is just python source, so has to be formatted as such
from commands import * 

karmafilename = "karmadump"

trouts = ("questions %s's parentage.",
          "slaps %s about a bit with a wet trout",
          "thumbs its nose at %s.")

selftroutrisk = 0.1 # some number between 0 and 1...
                    # the risk of a trout rebounding on the trouter!

initialtrouts = 5
maxtrouts = 5
trout_increment_time = 60 # in seconds
trout_increment_number = 2
trout_silence_delay = 60 # how long is trouting banned for after a nofish?
server = "arcor.de.eu.dal.net"

port = 6667

nickname = "^Acrobat"

channel = "#jcn"

owner = "Acronym"

triggers = ("!", "~") # what character should the bot be invoked by:
                      # eg !trout, ~trout etc.

# these are "command": (function in commands.py) pairs.

commands = {"karma": karmaq,
            "info": infoq,
            "trout": troutq,
            "reload": reloadq,
            "quit": quitq,
            "google": googleq,
            "say": sayq,
            "do": doq,
            "disconnect": disconnq,
            "hop": disconnq,
            "troutstock": troutquotaq,
            "fish_quota": troutquotaq,
            "nofish": nofishq,
            "list": listq,
            "help": listq
            }

# messages:

disconnect_message = "Be right back."
quit_message = "I have been chosen!"
